cSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG ;ALREADY SET BY DOS LOADER
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTPT:        JMP        setres                       ;COM FILE ENTRY ALWAYS AT 100H
; data areas
; the window is  32 columns by 23 lines
  db 'Reboot control. (c) Copyright July 9, 1985 by Keith P. Graham'
  db ' 238 Germonds Road, West Nyack, NY 10994'
reset     dd   0f000fff0h  ; finally found the absolute vector
rows     equ 12
cols     equ 31
windx    equ 4
windy    equ 4
color    equ 3fh
window   db  'ͻ' ;  201 ,205,187
         db  '    Resident Boot Control    ' ; 186
         db  '     by Keith P. Graham      ' ; 186
         db  ' 0. Exit                     ' ; 186
         db  ' 1. Reboot (Ctrl-Alt-Del)    ' ; 186
         db  ' 2. Reboot With Memory Check ' ; 186
         db  ' 3. Break (Ctrl-Break)       ' ; 186
         db  ' 4. Exit Current Program     ' ; 186
         db  ' 5. Break Current Program    ' ; 186
         db  ' 6. Exit through Function 4C ' ; 186
         db  ' 7. Reset Interrupts         ' ; 186
         db  'ͼ' ; 200,205,188
hidecurs dw  1014h
wsave  dw rows*cols dup(0)  ; 23 lines by 31 columns
printer  dw 0
cursor   dw  0
cursmode dw  0
bhpage   db  0
int9      dd  0
int9ip   equ word ptr int9
int9cs   equ word ptr int9 + 2
semaphore db  0
interrupts dw  256 dup(0)
START        PROC        NEAR
keyboard:
; we are entering here due to a key being struck
; first check the keyboard area to see if the CTRL and ALT are pressed
;
        push ax
        push es
        cmp  cs:semaphore,0
        jne  gotoint9
        mov  ax,40h
        mov  es,ax
        mov  al,byte ptr es:[17h]
        and  al,10
        cmp  al,10
        je   gotshift
gotoint9:
        pop  es
        pop  ax
        cli
        jmp  cs:int9
gotshift:
; faced with a dilema, the interrupt is no good
; are we in sidekick? lets find out
        pushf
        cli
        call cs:int9
        sti
gotac:
   ; check to see if the next key to come in is B  scan 48
        mov  ah,1
        int  16h
        cmp  ah,30h
        je   goforit
        pop  es
        pop  ax
        iret
goforit:
; save the world
        sti
        push bx
        push cx
        push dx
        push si
        push di
        push ds
; get the p so others won't be messed up
        mov  ah,0
        int  16h
        mov  ax,cs
        mov  ds,ax
        mov  es,ax
        mov   semaphore,1
        cld
; first get the cursor location
        call getcurs
        call getwind
        call putwind
getchar:
        jmp  gc2
nochar:
        call blop
gc2:
        call blip
        call getop
        cmp  al,0
        jne no0
        jmp  exit_prog
no0:
        cmp  al,1
        jne no27
        jmp  exit_prog
no27:
        cmp  al,11
        jne noh11
        jmp  exit_prog
noh11:
        cmp  al,2
        jne  no1
;  we reboot system by jumping to reset
;
        mov  ax,40h
        mov  es,ax
        mov  es:72h,1234h
        call retwind
        call retcurs
        mov   cs:semaphore,0
        jmp  reset
no1:
        cmp  al,3
        jne  no2
;  we reboot system by jumping to reset
;
        mov  ax,40h
        mov  es,ax
        mov  word ptr es:72h,0
        call retwind
        call retcurs
        mov   cs:semaphore,0
        jmp  reset
no2:
        cmp  al,4
        jne  no3
;  go to ctrl break address
;
        call retwind
        call retcurs
        mov   cs:semaphore,0
        int   1bh
        int   23h
        mov   cs:semaphore,1
        call getcurs
        call getwind
        call putwind
        call  blop
        call  blop
        call  blop
        call  blop
        jmp   getchar
no3:
        cmp  al,5
        jne  no4
        call retwind
        call retcurs
        pop  ds
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        pop  es
        pop  ax
        mov   cs:semaphore,0
; get and reset the psp
        mov   ah,51h
        mov   bx,0
        int   21h
; set the ds segment
        mov   ds,bx
        mov   es,bx
        mov   ah,50h
        int   21h
        int   20h
        int   1bh
no4:
        cmp  al,6
        jne  no5
        call retwind
        call retcurs
        pop  ds
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        pop  es
        pop  ax
        mov   cs:semaphore,0
; get and reset the psp
        mov   ah,51h
        mov   bx,0
        int   21h
; set the ds segment
        mov   ds,bx
        mov   es,bx
        mov   ah,50h
        int   21h
        int   1bh
        int   23h
        int   20h
no5:
        cmp  al,7
        jne  no6
        call retwind
        call retcurs
        pop  ds
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        pop  es
        pop  ax
        mov   cs:semaphore,0
; get and reset the psp
        mov   ah,51h
        mov   bx,0
        int   21h
; set the ds segment
        mov   ds,bx
        mov   es,bx
        mov   ah,50h
        int   21h
        mov   al,0ffh
        mov   ah,4ch
        int   21h
        int   20h
no6:
        cmp  al,8
        jne  no7
        push  cs
        pop   ds
        lea   si,interrupts
        mov   di,0
        push  es
        mov   es,di
        cld
        mov    cx,256
        cli
rep     movsw
        sti
        pop    es
        call   blip
        jmp   getchar
no7:
        jmp   nochar
exit_prog:
        call retwind
        call retcurs
        pop  ds
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        pop  es
        pop  ax
        mov   cs:semaphore,0
        iret
START        ENDP
getwind   proc near
; locate at the line 1 position 10
          lea  di,wsave
          mov  cx,rows
          mov  dh,windy
gwloop:
          push cx
          add  dh,1
          mov  dl,windx
          mov  cx,cols
gwloop2:
          inc  dl
          mov  ah,2
          mov  bh,bhpage
          int  10h
; get word at cursor
          mov  ah,8
          mov  bx,0
          int  10h
          stosw
          loop  gwloop2
          pop  cx
          loop gwloop
          ret
getwind   endp
putwind   proc near
; locate at the line 1 position 10
          lea  si,window
          mov  cx,rows
          mov  dh,windy
pwloop:
          push cx
          add  dh,1
          mov  dl,windx
          mov  cx,cols
pwloop2:
          push cx
          inc  dl
          mov  ah,2
          mov  bh,bhpage
          int  10h
; put word at cursor
          lodsb
          mov  ah,9
          mov  bh,bhpage
          mov  bl,color
          int  10h
          pop  cx
          loop  pwloop2
          pop  cx
          loop pwloop
; then  hide the cursor
          mov  dx,hidecurs
          mov  ah,2
          mov   bh,bhpage
          int   10h
          ret
putwind   endp
retwind   proc  near
; locate at the line 1 position 10
          lea  si,wsave
          mov  cx,rows
          mov  dh,windy
rwloop:
          push cx
          add  dh,1
          mov  dl,windx
          mov  cx,cols
rwloop2:
          push cx
          inc  dl
          mov  ah,2
          mov  bh,bhpage
          int  10h
; put word at cursor
          lodsw
      ;   ah has the  attribute, al, has the character
          mov  bl,ah
          mov  ah,9
          mov  bh,bhpage
          int  10h
          pop  cx
          loop  rwloop2
          pop  cx
          loop rwloop
          ret
retwind   endp
getcurs   proc  near
; get video state
          mov ah,15
          int 10h
          mov bhpage,bh
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcurs   endp
retcurs   proc  near
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          int  10h
          ret
retcurs   endp
getop     proc  near
; get the option
; us bios interrupts as DOS screws you on get character
getop2:
         mov   ah,0
         int   16h
         mov   al,ah
         ret
getop     endp
blip    proc  near
        mov   bx,250  ; starting freq
        mov   cx,750  ; ending frequency
        mov   dx,3    ; tone rate
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    si,32
        cmp    bx,cx
        jle    i1
        neg    si
i1:
        mov    cx,bx
 ; set frequency
        push   dx
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
        pop    dx
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
; mov   cx,dx
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        jg     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        ret
blip    endp
blop    proc  near
        mov   bx,650  ; starting freq
        mov   cx,150  ; ending frequency
        mov   dx,3    ; tone rate
; turn on tone
o0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    si,32
        mov    cx,bx
 ; set frequency
        push   dx
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
        pop    dx
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
; mov   cx,dx
o2:     loop o2
        pop    bx
        pop    cx
        cmp    bx,cx
        jl     op3
        sub    bx,si
        jmp    o0
op3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        ret
blop    endp
int161  proc near
      ; this imitates the 16h with ah 1
      ; returns the last character typed
      ; in ah (scan code)
      ; es has 40h in it
        mov bx,es:[1ah]
        mov ax,es:[bx]
        ret
int161  endp
setres  proc  near
; get the printer interrupt
startres:
        mov   ax,3509h
        int   21h
        mov   int9cs,es
        mov   int9ip,bx
        mov   ah,25h
        mov   al,9h
        lea   dx,keyboard
        int   21h
; save interrupts
        push  cs
        pop   es
        lea   di,interrupts
        mov   si,0
        push  ds
        mov   ds,si
        cld
        mov   cx,256
rep     movsw
        pop   ds
        lea   dx,mess1
        mov   ah,9
        int   21h
        lea   dx,startres
        int 27h
mess1   db  'Controlled Chaos Resident Re-booter. V2.0.',13,10
        db  'Press ALT-LEFT SHIFT-B for controlled reboot',13,10
        db  'Copyright 1987 by Keith P. Graham',13,10,10
        db  'If you find this program useful please mail',13,10
        db  'Five Dollars to:',13,10
        db  'Keith P. Graham',13,10
        db  '238 Germonds Road',13,10
        db  'West Nyack, New York 10994',13,10,10
        db  'thanks',13,10,'$'
setres  endp
CSEG        ENDS
        END        ENTPT
